<template lang="pug">
.field.is-marginless( v-if='$slots.default' )
	label.label.mb-2
		slot
.options.field.is-grouped( v-if='editor' )
	.control.is-expanded
		.buttons
			.button( @click='editor.chain().focus().toggleHeading({ level: 1 }).run()' :class='{ "is-black": editor.isActive("heading", { level: 1 }) }' ) H1
			.button( @click='editor.chain().focus().toggleHeading({ level: 2 }).run()' :class='{ "is-black": editor.isActive("heading", { level: 2 }) }' ) H2
			.button( @click='editor.chain().focus().toggleHeading({ level: 3 }).run()' :class='{ "is-black": editor.isActive("heading", { level: 3 }) }' ) H3

			.button( @click='editor.chain().focus().toggleBulletList().run()' :class='{ "is-black": editor.isActive("bulletList") }' )
				span.icon
					i.fa-solid.fa-list

			.button( @click='editor.chain().focus().toggleBold().run()' :class='{ "is-black": editor.isActive("bold") }' )
				span.has-text-weight-bold B

			.button( @click='editor.chain().focus().toggleItalic().run()' :class='{ "is-black": editor.isActive("italic") }' )
				span.is-italic I

			.button( @click='setLink' :class='{ "is-black": editor.isActive("link") }' )
				span {{$t("buttons.link")}}

			.button( @click='setArticle' :class='{ "is-black": editor.isActive("article") }' )
				span.icon
					i.fa-regular.fa-square
			
			.button( v-if='hasImages' @click='imageSelector = true' )
				span.icon
					i.fa-solid.fa-image
.field
	.control
		editor-content( :editor='editor' )

Teleport( to="body" )
	.modal.is-active( v-if='imageSelector' )
		.modal-background( @click='imageSelector = false' )
		.modal-content: files-manager( only-one @select='setImage' )
		.modal-close( @click='imageSelector = false' )
</template>

<script setup>
import { Node } from "@tiptap/core"
import { Editor, EditorContent } from "@tiptap/vue-3"
import Image from '@tiptap/extension-image'
import StarterKit from "@tiptap/starter-kit"
import Link from "@tiptap/extension-link"

import srcset from "@/common/srcset"
import { computed, onMounted, watch, ref, defineAsyncComponent } from "vue"
import { useI18n } from "vue-i18n"
import { useToast } from "vue-toastification"

const FilesManager = defineAsyncComponent(() => import("@/components/FilesManager/Manager.vue"))

const { t } = useI18n()
const toast = useToast()

const props = defineProps({ 
	modelValue: Object,
	hasImages: Boolean
})
const emit = defineEmits(["update:modelValue"])

const editor = ref()
const imageSelector = ref(false)

const noHeading = computed(() => !([2, 3, 4, 5]).find(level => editor.value.isActive("heading", { level })))

const heading = e => editor.value.chain().focus().toggleHeading({ level: parseInt(e.target.value) }).run()

const upd = ({ editor }) => {
	const html = editor.getHTML()
	emit("update:modelValue", { data: html == "<p></p>" ? "" : html })
}

watch(() => props.modelValue, (nv, ov) => {
	if (nv?.data?.trim() !== ov?.data?.trim()) {
		const { from, to } = editor.value?.state.selection

		editor.value?.commands.setContent(nv.data, true, { preserveWhitespace: true })

		editor.value?.commands.setTextSelection({ from, to })
	}
})

const setArticle = () => {
	editor.value.chain().focus().toggleWrap("article").run()
}

const setImage = ([ image ]) => {
	imageSelector.value = false
	editor.value.chain().focus().setImage({ src: srcset(image.name, "images")[1280] }).run()
}

const setLink = () => {
	const previousUrl = editor.value.getAttributes('link').href
	const url = window.prompt('URL', previousUrl)

	// cancelled
	if (url === null) {
		return
	}

	// empty
	if (url === '') {
		editor.value
			.chain()
			.focus()
			.extendMarkRange('link')
			.unsetLink()
			.run()

		return
	}

	editor.value
		.chain()
		.focus()
		.extendMarkRange('link')
		.setLink({ href: url })
		.run()
}

const Article = Node.create({
	name: "article",
	group: "block",
	content: "block+",
	parseHTML() {
    return [
      { tag: 'div' },
    ]
  },
  renderHTML({ HTMLAttributes }) {
    return ['div', { class: "article" }, 0]
  }
})

onMounted(() => {
	editor.value = new Editor({
		useBuiltInExtensions: false,
		extensions: [ 
			StarterKit, 
			Link,
			Article,
			Image.configure({
				allowBase64: true,
				HTMLAttributes: {
					crossorigin: "use-credentials"
				}
			})
		],
		content: props.modelValue?.data || "",
		editorProps: {
			attributes: {
				class: "textarea content"
			}
		},
		onUpdate: upd,
		onCreate: upd
	})
})
</script>

<style lang="scss" scoped>
.options {
	padding: .5rem;
	background: $white;
	box-shadow: 0 8px 8px rgb(10 10 10 / 10%);
	position: sticky;
	top: 0;
	z-index: 2;
}

.control {
	&:deep(.textarea) {
		font-family: "Montserrat", sans-serif;
		min-height: 40rem;
		max-height: unset;
		height: auto;
		h1, h2, h3 {
			font-weight: 700;
			text-align: center;
			&:not(:last-child) {
				margin-bottom: 1.1875rem;
			}
		}

		h2 {
			font-size: 2.625rem;
		}

		h3 {
			font-size: 2rem;
		}

		p + p {
			margin-top: 1rem;
		}

		.article {
			border-radius: 1rem;
			padding: 2rem;
		}

		.article h1 {
			font-size: 2.625rem;
		}

		.article > * {
			max-width: 664px;
			margin-right: auto;
			margin-left: auto;
		}

		.article:nth-of-type(2n + 1) {
			background: #F9F9F9;
		}

		.article + .article {
			margin-top: 1rem;
		}

		.article img {
			max-width: 100%!important;
			width: 100%;
			border-radius: 8px;
		}

		.article + h2 {
			margin-top: 1rem;
		}

		ul li p {
			text-align: left;
		}
	}
}

label.button {
	.icon {
		margin-left: calc(-0.5em - 1px)!important;
    margin-right: calc(-0.5em - 1px)!important;
	}
}

.modal-background {
	background: rgba($black, .2);
}

.modal-content {
	width: 90%;
	max-width: 900px;
}
</style>